ghc-9.6.3: The GHC API

Safe Haskell | Safe-Inferred
Language | Haskell2010

GHC.Core.Opt.OccurAnal

Synopsis

- occurAnalysePgm :: Module -> (Id -> Bool) -> (Activation -> Bool) -> [CoreRule] -> CoreProgram -> CoreProgram
- occurAnalyseExpr :: CoreExpr -> CoreExpr
- zapLambdaBndrs :: CoreExpr -> FullArgCount -> CoreExpr
- scrutBinderSwap_maybe :: OutExpr -> Maybe (OutVar, MCoercion)

# Documentation

occurAnalysePgm :: Module -> (Id -> Bool) -> (Activation -> Bool) -> [CoreRule] -> CoreProgram -> CoreProgram Source #

occurAnalyseExpr :: CoreExpr -> CoreExpr Source #

Do occurrence analysis, and discard occurrence info returned

zapLambdaBndrs :: CoreExpr -> FullArgCount -> CoreExpr Source #

scrutBinderSwap_maybe :: OutExpr -> Maybe (OutVar, MCoercion) Source #